package com.ldodds.twinkle.ui.action;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

import com.hp.hpl.jena.util.FileManager;
import com.ldodds.twinkle.ui.components.ComponentRegistry;
import com.ldodds.twinkle.ui.components.QueryForm;
import com.ldodds.twinkle.ui.components.BasicQueryFormOptions;
import com.ldodds.twinkle.ui.components.menu.FileMenu;

public final class ChooseDataCommand implements ActionListener
{
	final JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
    
    private BasicQueryFormOptions options;
    
    public ChooseDataCommand(BasicQueryFormOptions options) {
    	this.options = options;
        fc.addChoosableFileFilter(new FileNameExtensionFilter("Text File (.txt)","txt"));
        fc.addChoosableFileFilter(new FileNameExtensionFilter("XML Document (.xml)","xml"));            
        fc.addChoosableFileFilter(new FileNameExtensionFilter("N-Triples Document (.nt)","nt"));            
        fc.addChoosableFileFilter(new FileNameExtensionFilter("Turtle Document (.ttl)","ttl"));            
        fc.addChoosableFileFilter(new FileNameExtensionFilter("N3 Document (.n3)","n3"));            
        fc.addChoosableFileFilter(new FileNameExtensionFilter("OWL Document (.owl)","owl"));            
        fc.addChoosableFileFilter(new FileNameExtensionFilter("RDF Document (.rdf)","rdf"));            
      }
    
    public void actionPerformed(ActionEvent e)
    {
        if(FileMenu.lastDirectory!=null){
        	fc.setCurrentDirectory(FileMenu.lastDirectory);
        } 
        QueryForm queryFrame = ComponentRegistry.registry.getCurrentFrame();
        int result = fc.showDialog(queryFrame, "Choose Data File");
        if (result == JFileChooser.APPROVE_OPTION)
        {
            File lastFile = fc.getSelectedFile();
            FileMenu.lastDirectory = fc.getCurrentDirectory();
            options.getDataURL().setText(lastFile.toURI().toString() );
//            try {
//				String data= FileManager.get().readWholeFileAsUTF8(new FileInputStream(lastFile));
//				ComponentRegistry.registry.getCurrentFrame().dataField.setText(data);
//			} catch (FileNotFoundException e1) {
//				JOptionPane.showMessageDialog(null,"File not found at :"+result,
//            			"File not found", JOptionPane.ERROR_MESSAGE);
//			}
            ComponentRegistry.registry.getStatusBar().setMessage("Selected data file " + lastFile.getAbsolutePath());
        }
    }
}