package com.ldodds.twinkle.ui.action;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.text.BadLocationException;

import com.hp.hpl.jena.util.FileManager;
import com.ldodds.twinkle.ui.components.BasicQueryFormOptions;
import com.ldodds.twinkle.ui.components.ComponentRegistry;
import com.ldodds.twinkle.ui.components.QueryForm;

public class ShowDataCommand implements ActionListener {
    private BasicQueryFormOptions options;
    
    public ShowDataCommand(BasicQueryFormOptions options) {
    	this.options = options;
    }
    
	@Override
	public void actionPerformed(ActionEvent arg0) {
		QueryForm qf=ComponentRegistry.registry.getCurrentFrame();
		JSplitPane sp = qf.topSplitter;
		if(sp.getDividerLocation()>sp.getMaximumDividerLocation()) // data pane is closed
			sp.setDividerLocation(0.5); // show the data pane
		String dataURL=options.getDataURL().getText();
        if(dataURL==null || dataURL.length()==0)return;
        try {
        	URL url = new URL(dataURL);
            InputStream is = url.openConnection().getInputStream();
            String data = FileManager.get().readWholeFileAsUTF8(is) ;
            qf.dataField.setText(data);
            qf.dataField.setCaretPosition(0);
        } catch (MalformedURLException e1) {
		} catch (IOException e1) {
		}                
	}

}
